// python wrapper for vtkMemoryLimitImageDataStreamer
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInformationVector.h"
#include "vtkMemoryLimitImageDataStreamer.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMemoryLimitImageDataStreamer(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMemoryLimitImageDataStreamer_ClassNew(); }

#ifndef DECLARED_PyvtkImageDataStreamer_ClassNew
extern "C" { PyObject *PyvtkImageDataStreamer_ClassNew(); }
#define DECLARED_PyvtkImageDataStreamer_ClassNew
#endif

static const char *PyvtkMemoryLimitImageDataStreamer_Doc =
  "vtkMemoryLimitImageDataStreamer - Initiates streaming on image data.\n\n"
  "Superclass: vtkImageDataStreamer\n\n"
  "To satisfy a request, this filter calls update on its input many\n"
  "times with smaller update extents.  All processing up stream streams\n"
  "smaller pieces.\n\n";


static PyObject *
PyvtkMemoryLimitImageDataStreamer_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMemoryLimitImageDataStreamer::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMemoryLimitImageDataStreamer_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMemoryLimitImageDataStreamer *op = static_cast<vtkMemoryLimitImageDataStreamer *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMemoryLimitImageDataStreamer::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMemoryLimitImageDataStreamer_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMemoryLimitImageDataStreamer *tempr = vtkMemoryLimitImageDataStreamer::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMemoryLimitImageDataStreamer_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMemoryLimitImageDataStreamer *op = static_cast<vtkMemoryLimitImageDataStreamer *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMemoryLimitImageDataStreamer *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMemoryLimitImageDataStreamer::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMemoryLimitImageDataStreamer_SetMemoryLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMemoryLimitImageDataStreamer *op = static_cast<vtkMemoryLimitImageDataStreamer *>(vp);

  unsigned long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryLimit(temp0);
    }
    else
    {
      op->vtkMemoryLimitImageDataStreamer::SetMemoryLimit(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMemoryLimitImageDataStreamer_GetMemoryLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMemoryLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMemoryLimitImageDataStreamer *op = static_cast<vtkMemoryLimitImageDataStreamer *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMemoryLimit() :
      op->vtkMemoryLimitImageDataStreamer::GetMemoryLimit());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMemoryLimitImageDataStreamer_Methods[] = {
  {"IsTypeOf", PyvtkMemoryLimitImageDataStreamer_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMemoryLimitImageDataStreamer_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMemoryLimitImageDataStreamer_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMemoryLimitImageDataStreamer\nC++: static vtkMemoryLimitImageDataStreamer *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMemoryLimitImageDataStreamer_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMemoryLimitImageDataStreamer\nC++: vtkMemoryLimitImageDataStreamer *NewInstance()\n\n"},
  {"SetMemoryLimit", PyvtkMemoryLimitImageDataStreamer_SetMemoryLimit, METH_VARARGS,
   "V.SetMemoryLimit(int)\nC++: virtual void SetMemoryLimit(unsigned long _arg)\n\nSet / Get the memory limit in kibibytes (1024 bytes).\n"},
  {"GetMemoryLimit", PyvtkMemoryLimitImageDataStreamer_GetMemoryLimit, METH_VARARGS,
   "V.GetMemoryLimit() -> int\nC++: virtual unsigned long GetMemoryLimit()\n\nSet / Get the memory limit in kibibytes (1024 bytes).\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMemoryLimitImageDataStreamer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelImagingPython.vtkMemoryLimitImageDataStreamer", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  nullptr, // tp_print
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMemoryLimitImageDataStreamer_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMemoryLimitImageDataStreamer_StaticNew()
{
  return vtkMemoryLimitImageDataStreamer::New();
}

PyObject *PyvtkMemoryLimitImageDataStreamer_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMemoryLimitImageDataStreamer_Type, PyvtkMemoryLimitImageDataStreamer_Methods,
    "vtkMemoryLimitImageDataStreamer",
 &PyvtkMemoryLimitImageDataStreamer_StaticNew);

  PyTypeObject *pytype = &PyvtkMemoryLimitImageDataStreamer_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageDataStreamer_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMemoryLimitImageDataStreamer(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMemoryLimitImageDataStreamer_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMemoryLimitImageDataStreamer", o) != 0)
  {
    Py_DECREF(o);
  }

}

