// python wrapper for vtkInSituPParticlePathFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInSituPParticlePathFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkInSituPParticlePathFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkInSituPParticlePathFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPParticlePathFilter_ClassNew
extern "C" { PyObject *PyvtkPParticlePathFilter_ClassNew(); }
#define DECLARED_PyvtkPParticlePathFilter_ClassNew
#endif

static const char *PyvtkInSituPParticlePathFilter_Doc =
  "vtkInSituPParticlePathFilter - An In Situ Particle tracer for\nunsteady vector fields\n\n"
  "Superclass: vtkPParticlePathFilter\n\n"
  "vtkInSituPParticlePathFilter is a filter that integrates a vector\n"
  "field to generate particle paths. It is intended for in situ use. The\n"
  "additions to the parallel particle path filter is that the particle\n"
  "locations at previous time steps can be cleared out (ClearCache data\n"
  "member) and restarted connection can be used to continue advecting\n"
  "particles from a restarted simulation.\n"
  "@sa\n"
  "vtkPParticlePathFilterBase has the details of the algorithms\n\n";


static PyObject *
PyvtkInSituPParticlePathFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkInSituPParticlePathFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkInSituPParticlePathFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkInSituPParticlePathFilter *tempr = vtkInSituPParticlePathFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkInSituPParticlePathFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkInSituPParticlePathFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_SetClearCache(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetClearCache");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetClearCache(temp0);
    }
    else
    {
      op->vtkInSituPParticlePathFilter::SetClearCache(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_AddRestartConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddRestartConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->AddRestartConnection(temp0);
    }
    else
    {
      op->vtkInSituPParticlePathFilter::AddRestartConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_RemoveAllRestarts(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllRestarts");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllRestarts();
    }
    else
    {
      op->vtkInSituPParticlePathFilter::RemoveAllRestarts();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_SetRestartedSimulation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRestartedSimulation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRestartedSimulation(temp0);
    }
    else
    {
      op->vtkInSituPParticlePathFilter::SetRestartedSimulation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_GetRestartedSimulation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRestartedSimulation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetRestartedSimulation() :
      op->vtkInSituPParticlePathFilter::GetRestartedSimulation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_SetFirstTimeStep(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFirstTimeStep");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFirstTimeStep(temp0);
    }
    else
    {
      op->vtkInSituPParticlePathFilter::SetFirstTimeStep(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInSituPParticlePathFilter_GetFirstTimeStep(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFirstTimeStep");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInSituPParticlePathFilter *op = static_cast<vtkInSituPParticlePathFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFirstTimeStep() :
      op->vtkInSituPParticlePathFilter::GetFirstTimeStep());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkInSituPParticlePathFilter_Methods[] = {
  {"IsTypeOf", PyvtkInSituPParticlePathFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkInSituPParticlePathFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkInSituPParticlePathFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkInSituPParticlePathFilter\nC++: static vtkInSituPParticlePathFilter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkInSituPParticlePathFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkInSituPParticlePathFilter\nC++: vtkInSituPParticlePathFilter *NewInstance()\n\n"},
  {"SetClearCache", PyvtkInSituPParticlePathFilter_SetClearCache, METH_VARARGS,
   "V.SetClearCache(bool)\nC++: void SetClearCache(bool)\n\nSet whether or not to clear out cache of previous time steps.\nDefault value is false. Clearing the cache is aimed towards in\nsitu use.\n"},
  {"AddRestartConnection", PyvtkInSituPParticlePathFilter_AddRestartConnection, METH_VARARGS,
   "V.AddRestartConnection(vtkAlgorithmOutput)\nC++: void AddRestartConnection(vtkAlgorithmOutput *input)\n\nProvide support pre-pending previously computed particle paths.\n"},
  {"RemoveAllRestarts", PyvtkInSituPParticlePathFilter_RemoveAllRestarts, METH_VARARGS,
   "V.RemoveAllRestarts()\nC++: void RemoveAllRestarts()\n\nProvide support pre-pending previously computed particle paths.\n"},
  {"SetRestartedSimulation", PyvtkInSituPParticlePathFilter_SetRestartedSimulation, METH_VARARGS,
   "V.SetRestartedSimulation(bool)\nC++: virtual void SetRestartedSimulation(bool _arg)\n\nSet/Get if the simulation has been restarted. If it is a\nrestarted simulation we may not necessarily want to\ninject/reinject particles on the first time step. The default is\nFalse.\n"},
  {"GetRestartedSimulation", PyvtkInSituPParticlePathFilter_GetRestartedSimulation, METH_VARARGS,
   "V.GetRestartedSimulation() -> bool\nC++: virtual bool GetRestartedSimulation()\n\nSet/Get if the simulation has been restarted. If it is a\nrestarted simulation we may not necessarily want to\ninject/reinject particles on the first time step. The default is\nFalse.\n"},
  {"SetFirstTimeStep", PyvtkInSituPParticlePathFilter_SetFirstTimeStep, METH_VARARGS,
   "V.SetFirstTimeStep(int)\nC++: virtual void SetFirstTimeStep(int _arg)\n\nSpecify the first time step that particle paths are computed.\nThis is useful for restarted simulations or when the simulation's\nfirst time step isn't 0. The default is 0.\n"},
  {"GetFirstTimeStep", PyvtkInSituPParticlePathFilter_GetFirstTimeStep, METH_VARARGS,
   "V.GetFirstTimeStep() -> int\nC++: virtual int GetFirstTimeStep()\n\nSpecify the first time step that particle paths are computed.\nThis is useful for restarted simulations or when the simulation's\nfirst time step isn't 0. The default is 0.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkInSituPParticlePathFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkInSituPParticlePathFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  nullptr, // tp_print
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkInSituPParticlePathFilter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkInSituPParticlePathFilter_StaticNew()
{
  return vtkInSituPParticlePathFilter::New();
}

PyObject *PyvtkInSituPParticlePathFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkInSituPParticlePathFilter_Type, PyvtkInSituPParticlePathFilter_Methods,
    "vtkInSituPParticlePathFilter",
 &PyvtkInSituPParticlePathFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkInSituPParticlePathFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPParticlePathFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkInSituPParticlePathFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkInSituPParticlePathFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkInSituPParticlePathFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

