// python wrapper for vtkPLineIntegralConvolution2D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPLineIntegralConvolution2D.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPLineIntegralConvolution2D(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPLineIntegralConvolution2D_ClassNew(); }

#ifndef DECLARED_PyvtkLineIntegralConvolution2D_ClassNew
extern "C" { PyObject *PyvtkLineIntegralConvolution2D_ClassNew(); }
#define DECLARED_PyvtkLineIntegralConvolution2D_ClassNew
#endif

static const char *PyvtkPLineIntegralConvolution2D_Doc =
  "vtkPLineIntegralConvolution2D - parallel part of GPU-based\nimplementation of Line Integral Convolution (LIC)\n\n"
  "Superclass: vtkLineIntegralConvolution2D\n\n"
  "Implements the parallel parts of the algorithm.\n\n"
  "@sa\n"
  " vtkPLineIntegralConvolution2D\n\n";


static PyObject *
PyvtkPLineIntegralConvolution2D_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPLineIntegralConvolution2D::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPLineIntegralConvolution2D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPLineIntegralConvolution2D *op = static_cast<vtkPLineIntegralConvolution2D *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPLineIntegralConvolution2D::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPLineIntegralConvolution2D_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPLineIntegralConvolution2D *tempr = vtkPLineIntegralConvolution2D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPLineIntegralConvolution2D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPLineIntegralConvolution2D *op = static_cast<vtkPLineIntegralConvolution2D *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPLineIntegralConvolution2D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPLineIntegralConvolution2D::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPLineIntegralConvolution2D_WriteTimerLog(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteTimerLog");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPLineIntegralConvolution2D *op = static_cast<vtkPLineIntegralConvolution2D *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->WriteTimerLog(temp0);
    }
    else
    {
      op->vtkPLineIntegralConvolution2D::WriteTimerLog(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPLineIntegralConvolution2D_Methods[] = {
  {"IsTypeOf", PyvtkPLineIntegralConvolution2D_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPLineIntegralConvolution2D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPLineIntegralConvolution2D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPLineIntegralConvolution2D\nC++: static vtkPLineIntegralConvolution2D *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPLineIntegralConvolution2D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPLineIntegralConvolution2D\nC++: vtkPLineIntegralConvolution2D *NewInstance()\n\n"},
  {"WriteTimerLog", PyvtkPLineIntegralConvolution2D_WriteTimerLog, METH_VARARGS,
   "V.WriteTimerLog(string)\nC++: virtual void WriteTimerLog(const char *fileName) override;\n\nMethods used for parallel benchmarks. Use cmake to define\nvtkLineIntegralConviolution2DTIME to enable benchmarks. During\neach update timing information is stored, it can be written to\ndisk by calling WriteLog.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPLineIntegralConvolution2D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingParallelLICPython.vtkPLineIntegralConvolution2D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  nullptr, // tp_print
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPLineIntegralConvolution2D_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPLineIntegralConvolution2D_StaticNew()
{
  return vtkPLineIntegralConvolution2D::New();
}

PyObject *PyvtkPLineIntegralConvolution2D_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPLineIntegralConvolution2D_Type, PyvtkPLineIntegralConvolution2D_Methods,
    "vtkPLineIntegralConvolution2D",
 &PyvtkPLineIntegralConvolution2D_StaticNew);

  PyTypeObject *pytype = &PyvtkPLineIntegralConvolution2D_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkLineIntegralConvolution2D_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPLineIntegralConvolution2D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPLineIntegralConvolution2D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPLineIntegralConvolution2D", o) != 0)
  {
    Py_DECREF(o);
  }

}

