// python wrapper for vtkPUniformGridGhostDataGenerator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPUniformGridGhostDataGenerator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPUniformGridGhostDataGenerator(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPUniformGridGhostDataGenerator_ClassNew(); }

#ifndef DECLARED_PyvtkPDataSetGhostGenerator_ClassNew
extern "C" { PyObject *PyvtkPDataSetGhostGenerator_ClassNew(); }
#define DECLARED_PyvtkPDataSetGhostGenerator_ClassNew
#endif

static const char *PyvtkPUniformGridGhostDataGenerator_Doc =
  "vtkPUniformGridGhostDataGenerator -  uniform grids.\n\n"
  "Superclass: vtkPDataSetGhostGenerator\n\n"
  "A concrete implementation of vtkPDataSetGhostGenerator for generating\n"
  "ghost\n"
  " data on a partitioned and distributed domain of uniform grids.\n\n"
  "@warning\n"
  " \n"
  "  \n"
  "   The input multi-block dataset must:\n"
  "   \n"
  "     Have the whole-extent set \n"
  "     Each block must be an instance of vtkUniformGrid \n"
  "     Each block must have its corresponding global extent set in the\n"
  "          meta-data using the PIECE_EXTENT() key \n"
  "     The spacing of each block is the same \n"
  "     All blocks must have the same fields loaded \n"
  "     The multi-block structure is consistent on all processes \n"
  "   \n"
  "  \n"
  "  \n"
  "   The code currently does not handle the following cases:\n"
  "   \n"
  "     Periodic boundaries\n"
  "     Growing ghost layers beyond the extents of the neighboring grid\n"
  "   \n"
  "  \n"
  " \n\n"
  "@sa\n"
  "vtkDataSetGhostGenerator,vtkUniformGhostDataGenerator,\n"
  "vtkPDataSetGhostGenerator\n\n";


static PyObject *
PyvtkPUniformGridGhostDataGenerator_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPUniformGridGhostDataGenerator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUniformGridGhostDataGenerator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUniformGridGhostDataGenerator *op = static_cast<vtkPUniformGridGhostDataGenerator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPUniformGridGhostDataGenerator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUniformGridGhostDataGenerator_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPUniformGridGhostDataGenerator *tempr = vtkPUniformGridGhostDataGenerator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUniformGridGhostDataGenerator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUniformGridGhostDataGenerator *op = static_cast<vtkPUniformGridGhostDataGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPUniformGridGhostDataGenerator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPUniformGridGhostDataGenerator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkPUniformGridGhostDataGenerator_Methods[] = {
  {"IsTypeOf", PyvtkPUniformGridGhostDataGenerator_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPUniformGridGhostDataGenerator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPUniformGridGhostDataGenerator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPUniformGridGhostDataGenerator\nC++: static vtkPUniformGridGhostDataGenerator *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPUniformGridGhostDataGenerator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPUniformGridGhostDataGenerator\nC++: vtkPUniformGridGhostDataGenerator *NewInstance()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPUniformGridGhostDataGenerator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelGeometryPython.vtkPUniformGridGhostDataGenerator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  nullptr, // tp_print
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPUniformGridGhostDataGenerator_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPUniformGridGhostDataGenerator_StaticNew()
{
  return vtkPUniformGridGhostDataGenerator::New();
}

PyObject *PyvtkPUniformGridGhostDataGenerator_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPUniformGridGhostDataGenerator_Type, PyvtkPUniformGridGhostDataGenerator_Methods,
    "vtkPUniformGridGhostDataGenerator",
 &PyvtkPUniformGridGhostDataGenerator_StaticNew);

  PyTypeObject *pytype = &PyvtkPUniformGridGhostDataGenerator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPDataSetGhostGenerator_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPUniformGridGhostDataGenerator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPUniformGridGhostDataGenerator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPUniformGridGhostDataGenerator", o) != 0)
  {
    Py_DECREF(o);
  }

}

