// Loadable modules
//
// Generated by ../../bin/vtkkwProcessXML
//
#ifndef __vtkSMXML_AdiosClientOnly_h
#define __vtkSMXML_AdiosClientOnly_h

#include <string.h>
#include <cassert>
#include <algorithm>


// From file /builddir/build/BUILD/ParaView-v5.6.0/Plugins/AdiosReader/Adios.xml
static const char* const AdiosClientOnlyAdiosInterfaces0 =
"<ServerManagerConfiguration>\n"
"  <ProxyGroup name=\"sources\">\n"
"    <SourceProxy name=\"PixieAdiosReader\" class=\"vtkAdiosPixieReader\" label=\"ADIOS Pixie Reader\">\n"
"      <Documentation\n"
"         short_help=\"Read Adios Pixie files.\"\n"
"         long_help=\"Load the geometry and data from a bp adios file.\">\n"
"      </Documentation>\n"
"      <StringVectorProperty\n"
"          name=\"FileName\"\n"
"          animateable=\"0\"\n"
"          command=\"SetFileName\"\n"
"          number_of_elements=\"1\"\n"
"          panel_visibility=\"never\">\n"
"          <FileListDomain name=\"files\"/>\n"
"          <Documentation>\n"
"            This property specifies the file name for the ADIOS reader.\n"
"          </Documentation>\n"
"      </StringVectorProperty>\n"
"\n"
"      <IntVectorProperty\n"
"          name=\"ReadMethod\"\n"
"          command=\"SetReadMethod\"\n"
"          number_of_elements=\"1\"\n"
"          default_values=\"0\"\n"
"          label=\"Read Method\"\n"
"          panel_visibility=\"never\">\n"
"          <EnumerationDomain name=\"enum\">\n"
"            <Entry value=\"0\" text=\"BP File\"/>\n"
"            <Entry value=\"3\" text=\"DATASPACES\"/>\n"
"          </EnumerationDomain>\n"
"       </IntVectorProperty>\n"
"\n"
"      <StringVectorProperty\n"
"          name=\"Parameters\"\n"
"          animateable=\"0\"\n"
"          command=\"SetParameters\"\n"
"          number_of_elements=\"1\"\n"
"          default_values=\"verbose=3; app_id=5\"\n"
"          panel_visibility=\"never\"/>\n"
"\n"
"       <Property\n"
"           name=\"NextStep\"\n"
"           command=\"NextStep\"\n"
"           panel_widget=\"command_button\"/>\n"
"\n"
"       <Property\n"
"           name=\"Reset\"\n"
"           command=\"Reset\"\n"
"           panel_widget=\"command_button\"/>\n"
"\n"
"       <Hints>\n"
"          <ReaderFactory extensions=\"bp\" file_description=\"Pixie Adios file (Plugin)\"/>\n"
"       </Hints>\n"
"    </SourceProxy>\n"
"\n"
"    <SourceProxy name=\"PixieAdiosStream\" class=\"vtkAdiosPixieReader\" label=\"ADIOS Pixie Stream Source\">\n"
"      <Documentation\n"
"         short_help=\"Read Adios Pixie stream.\"\n"
"         long_help=\"Load the geometry and data from a adios stage stream.\">\n"
"      </Documentation>\n"
"      <StringVectorProperty\n"
"          name=\"FileName\"\n"
"          animateable=\"0\"\n"
"          command=\"SetFileName\"\n"
"          number_of_elements=\"1\" >\n"
"          <Documentation>\n"
"            This property specifies the file name for the ADIOS stream.\n"
"          </Documentation>\n"
"      </StringVectorProperty>\n"
"\n"
"      <IntVectorProperty\n"
"          name=\"ReadMethod\"\n"
"          command=\"SetReadMethod\"\n"
"          number_of_elements=\"1\"\n"
"          default_values=\"3\"\n"
"          label=\"Read Method\"\n"
"          panel_visibility=\"never\">\n"
"          <EnumerationDomain name=\"enum\">\n"
"            <Entry value=\"0\" text=\"BP File\"/>\n"
"            <Entry value=\"3\" text=\"DATASPACES\"/>\n"
"          </EnumerationDomain>\n"
"       </IntVectorProperty>\n"
"\n"
"      <StringVectorProperty\n"
"          name=\"Parameters\"\n"
"          animateable=\"0\"\n"
"          command=\"SetParameters\"\n"
"          number_of_elements=\"1\"\n"
"          default_values=\"verbose=3; app_id=5\"\n"
"          panel_visibility=\"never\"/>\n"
"\n"
"       <Property\n"
"           name=\"NextStep\"\n"
"           command=\"NextStep\"\n"
"           panel_widget=\"command_button\"/>\n"
"\n"
"       <Property\n"
"           name=\"Reset\"\n"
"           command=\"Reset\"\n"
"           panel_widget=\"command_button\"/>\n"
"\n"
"       <Hints>\n"
"         <ReaderFactory extensions=\"bp\"\n"
"                        file_description=\"Pixie Adios file (Plugin)\" />\n"
"           <ShowInMenu/>\n"
"       </Hints>\n"
"    </SourceProxy>\n"
"  </ProxyGroup>\n"
"</ServerManagerConfiguration>\n"
"\n";
// Get single string
char* AdiosClientOnlyAdiosInterfaces()
{

  const size_t len0 = strlen(AdiosClientOnlyAdiosInterfaces0);
  size_t len = ( 0
    + len0 );
  char* res = new char[ len + 1];
  size_t offset = 0;
  std::copy(AdiosClientOnlyAdiosInterfaces0, AdiosClientOnlyAdiosInterfaces0 + len0, res + offset); offset += len0;
  assert(offset == len);
  res[offset] = 0;
  return res;
}



#endif
