// Loadable modules
//
// Generated by ../../bin/vtkkwProcessXML
//
#ifndef __vtkSMXML_CDIReader_h
#define __vtkSMXML_CDIReader_h

#include <string.h>
#include <cassert>
#include <algorithm>


// From file /builddir/build/BUILD/ParaView-v5.6.0/Plugins/CDIReader/CDIReader.xml
static const char* const CDIReaderCDIReaderInterfaces0 =
"<ServerManagerConfiguration>\n"
"  <ProxyGroup name=\"sources\">\n"
"    <!-- ================================================================== -->\n"
"    <SourceProxy name=\"vtkCDIReader\" class=\"vtkCDIReader\" label=\"CDIReader\">\n"
"      <Documentation\n"
"        long_help=\"Reads CDI/ICON netCDF data.\"\n"
"        short_help=\"Reads CDI/ICON netCDF data.\">\n"
"      </Documentation>\n"
"      <StringVectorProperty\n"
"            name=\"FileName\"\n"
"            animateable=\"0\"\n"
"            command=\"SetFileName\"\n"
"            number_of_elements=\"1\">\n"
"        <FileListDomain name=\"files\"/>\n"
"        <Documentation>\n"
"          This property specifies the netCDF file name for the CDI/ICON reader.\n"
"        </Documentation>\n"
"      </StringVectorProperty>\n"
"\n"
"      <Hints>\n"
"        <ReaderFactory extensions=\"nc\"\n"
"                      file_description=\"CDI netCDF Reader (ICON)\" />\n"
"    </Hints>\n"
"\n"
"      <StringVectorProperty command=\"GetAllDimensions\"\n"
"                            information_only=\"1\"\n"
"                            name=\"DimensionInfo\">\n"
"        <StringArrayHelper />\n"
"      </StringVectorProperty>\n"
"      <StringVectorProperty animatelable=\"0\"\n"
"                            command=\"SetDimensions\"\n"
"                            name=\"Dimensions\"\n"
"                            number_of_elements=\"1\"\n"
"                            panel_visibility=\"default\">\n"
"        <StringListDomain name=\"array_list\">\n"
"          <RequiredProperties>\n"
"            <Property function=\"ArrayList\"\n"
"                      name=\"DimensionInfo\" />\n"
"          </RequiredProperties>\n"
"        </StringListDomain>\n"
"        <Documentation>Load the grid with the given dimensions. Arrays that\n"
"        conform to these dimensions will be displayed and loaded.</Documentation>\n"
"      </StringVectorProperty>\n"
"      <StringVectorProperty command=\"GetVariableDimensions\"\n"
"                            information_only=\"1\"\n"
"                            name=\"VariableDimensionInfo\">\n"
"        <StringArrayHelper />\n"
"      </StringVectorProperty>\n"
"      <StringVectorProperty command=\"GetAllVariableArrayNames\"\n"
"                            information_only=\"1\"\n"
"                            name=\"VariableArrayInfo\">\n"
"        <StringArrayHelper />\n"
"      </StringVectorProperty>\n"
"\n"
"    <!--Gui Parameter -->\n"
"    <StringVectorProperty\n"
"        name=\"PointArrayInfo\"\n"
"        information_only=\"1\">\n"
"    <ArraySelectionInformationHelper attribute_name=\"Point\"/>\n"
"    </StringVectorProperty>\n"
"\n"
"    <StringVectorProperty\n"
"        name=\"PointArrayStatus\"\n"
"        command=\"SetPointArrayStatus\"\n"
"        number_of_elements=\"2\"\n"
"        repeat_command=\"1\"\n"
"        number_of_elements_per_command=\"2\"\n"
"        element_types=\"2 0\"\n"
"        information_property=\"PointArrayInfo\" >\n"
"    <ArraySelectionDomain name=\"array_list\" >\n"
"        <RequiredProperties>\n"
"            <Property name=\"PointArrayInfo\" function=\"ArrayList\"/>\n"
"        </RequiredProperties>\n"
"    </ArraySelectionDomain>\n"
"        <Documentation>\n"
"          This list shows the available ICON point variables.\n"
"        </Documentation>\n"
"    </StringVectorProperty>\n"
"\n"
"    <StringVectorProperty\n"
"        name=\"CellArrayInfo\"\n"
"        information_only=\"1\" >\n"
"    <ArraySelectionInformationHelper attribute_name=\"Cell\"/>\n"
"    </StringVectorProperty>\n"
"\n"
"    <StringVectorProperty\n"
"        name=\"CellArrayStatus\"\n"
"        command=\"SetCellArrayStatus\"\n"
"        number_of_elements=\"2\"\n"
"        repeat_command=\"1\"\n"
"        number_of_elements_per_command=\"2\"\n"
"        element_types=\"2 0\"\n"
"        information_property=\"CellArrayInfo\" >\n"
"    <ArraySelectionDomain name=\"array_list\" >\n"
"        <RequiredProperties>\n"
"            <Property name=\"CellArrayInfo\" function=\"ArrayList\"/>\n"
"        </RequiredProperties>\n"
"    </ArraySelectionDomain>\n"
"        <Documentation>\n"
"          This list shows the available ICON cell variables.\n"
"        </Documentation>\n"
"    </StringVectorProperty>\n"
"\n"
"    <StringVectorProperty\n"
"        name=\"DomainArrayInfo\"\n"
"        information_only=\"1\" >\n"
"    <ArraySelectionInformationHelper attribute_name=\"Domain\"/>\n"
"    </StringVectorProperty>\n"
"\n"
"    <StringVectorProperty\n"
"        name=\"DomainArrayStatus\"\n"
"        command=\"SetDomainArrayStatus\"\n"
"        number_of_elements=\"2\"\n"
"        repeat_command=\"1\"\n"
"        number_of_elements_per_command=\"2\"\n"
"        element_types=\"2 0\"\n"
"        information_property=\"DomainArrayInfo\" >\n"
"    <ArraySelectionDomain name=\"array_list\" >\n"
"        <RequiredProperties>\n"
"            <Property name=\"DomainArrayInfo\" function=\"ArrayList\"/>\n"
"        </RequiredProperties>\n"
"    </ArraySelectionDomain>\n"
"        <Documentation>\n"
"          This list shows the available ICON domain variables (for simulation performance analysis).\n"
"        </Documentation>\n"
"    </StringVectorProperty>\n"
"\n"
"    <IntVectorProperty\n"
"        name=\"Project Lat/Lon\"\n"
"        command=\"SetProjectLatLon\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"0\">\n"
"      <BooleanDomain name=\"bool\" />\n"
"        <Documentation>\n"
"          Switch on for equidistant cylindrical (lat/lon) projection.\n"
"        </Documentation>\n"
"    </IntVectorProperty>\n"
"\n"
"    <IntVectorProperty\n"
"        name=\"Project Cassini\"\n"
"        command=\"SetProjectCassini\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"0\">\n"
"      <BooleanDomain name=\"bool\" />\n"
"        <Documentation>\n"
"          Switch on for Cassini projection.\n"
"        </Documentation>\n"
"    </IntVectorProperty>\n"
"\n"
"      <IntVectorProperty\n"
"        name=\"UseTopography\"\n"
"        label=\"Use Topography (wet_c)\"\n"
"        command=\"SetTopography\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"0\">\n"
"      <BooleanDomain name=\"bool\" />\n"
"        <Documentation>\n"
"          Switch on to remove land structure contained in the variable \"wet_c\".\n"
"        </Documentation>\n"
"    </IntVectorProperty>\n"
"\n"
"      <IntVectorProperty\n"
"        name=\"SetInvertTopography\"\n"
"        label=\"Use Land/Sea for Masking (Off = Sea; On = Land)\"\n"
"        command=\"InvertTopography\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"0\">\n"
"      <BooleanDomain name=\"bool\" />\n"
"        <Documentation>\n"
"          Switch to either remove land or sea structure contained within the variable \"wet_c\".\n"
"        </Documentation>\n"
"    </IntVectorProperty>\n"
"\n"
"      <IntVectorProperty\n"
"        name=\"InvertZ\"\n"
"        label=\"Invert Z-Axis\"\n"
"        command=\"SetInvertZAxis\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"0\">\n"
"      <BooleanDomain name=\"bool\" />\n"
"        <Documentation>\n"
"          Switch on to invert the rendering of the z-axis.\n"
"        </Documentation>\n"
"    </IntVectorProperty>\n"
"\n"
"    <IntVectorProperty\n"
"        name=\"Show3DSurface\"\n"
"        label=\"Show 3D Surface\"\n"
"        command=\"SetShowMultilayerView\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"0\">\n"
"      <BooleanDomain name=\"bool\" />\n"
"        <Documentation>\n"
"          Switch on for 3D rendering of the data. 2D arrays display the same value on all levels.\n"
"        </Documentation>\n"
"    </IntVectorProperty>\n"
"\n"
"    <IntVectorProperty\n"
"        name=\"LayerThicknessRangeInfo\"\n"
"        command=\"GetLayerThicknessRange\"\n"
"        information_only=\"1\">\n"
"        <SimpleIntInformationHelper/>\n"
"    </IntVectorProperty>\n"
"\n"
"    <IntVectorProperty\n"
"        name=\"LayerThickness\"\n"
"        label=\"3D Surface Thickness\"\n"
"        command=\"SetLayerThickness\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"10\">\n"
"      <IntRangeDomain name=\"LayerThicknessRange\">\n"
"      <RequiredProperties>\n"
"        <Property name=\"LayerThicknessRangeInfo\" function=\"Range\"/>\n"
"      </RequiredProperties>\n"
"      </IntRangeDomain>\n"
"      <Documentation>\n"
"      Adjust the layer thickness for 3D rendering.\n"
"      </Documentation>   <Hints>\n"
"    <!-- Visibility Element can be used to suggest the GUI about\n"
"          visibility of this filter (or its input) on creation.\n"
"          replace_input=\"0\" implies that the input visibility is not\n"
"            changed on creation of this filter (defaults to \"1\")\n"
"      -->\n"
"    <Visibility replace_input=\"1\" />\n"
"  </Hints>\n"
"    </IntVectorProperty>\n"
"\n"
"    <IntVectorProperty\n"
"        name=\"VerticalLevelRangeInfo\"\n"
"        command=\"GetVerticalLevelRange\"\n"
"        information_only=\"1\">\n"
"      <SimpleIntInformationHelper/>\n"
"    </IntVectorProperty>\n"
"\n"
"    <IntVectorProperty\n"
"        name=\"VerticalLevel\"\n"
"        command=\"SetVerticalLevel\"\n"
"        number_of_elements=\"1\"\n"
"        default_values=\"0\">\n"
"      <IntRangeDomain name=\"range\" >\n"
"        <RequiredProperties>\n"
"          <Property name=\"VerticalLevelRangeInfo\" function=\"Range\"/>\n"
"        </RequiredProperties>\n"
"      </IntRangeDomain>\n"
"      <Documentation>\n"
"      Adjust the vertical level that is displayed. This is only available for 3D data sets.\n"
"      </Documentation>\n"
"    </IntVectorProperty>\n"
"\n"
"    <DoubleVectorProperty\n"
"        name=\"TimestepValues\"\n"
"        repeatable=\"1\"\n"
"        information_only=\"1\">\n"
"      <TimeStepsInformationHelper/>\n"
"    </DoubleVectorProperty>\n"
"\n"
"    </SourceProxy>\n"
"    <!-- End ICONReader -->\n"
"  </ProxyGroup>\n"
"  <!-- End Filters Group -->\n"
"</ServerManagerConfiguration>\n"
"\n";
// Get single string
char* CDIReaderCDIReaderInterfaces()
{

  const size_t len0 = strlen(CDIReaderCDIReaderInterfaces0);
  size_t len = ( 0
    + len0 );
  char* res = new char[ len + 1];
  size_t offset = 0;
  std::copy(CDIReaderCDIReaderInterfaces0, CDIReaderCDIReaderInterfaces0 + len0, res + offset); offset += len0;
  assert(offset == len);
  res[offset] = 0;
  return res;
}



#endif
